/*
Copyright 2007 Darren Watts

This file is part of JuiceFlag.

JuiceFlag is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JuiceFlag is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JuiceFlag; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.*;

/**
 * @author Darren Watts
 * @version 1.0
 */
public class JUICEFrame
    extends JFrame {

  private JUICEModel jm;

  public JUICEFrame() {
    jm = new JUICEModel(this);
    try {
      jbInit();
    }
    catch (Exception exception) {
      exception.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    getContentPane().setLayout(null);
    this.setJMenuBar(jMenuBar1);
    jMenu1.setText("File");
    jMenuItem1.setText("Open");
    jMenuItem1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem1_actionPerformed(e);
      }
    });
    chkSinglePlr.setText("Single Player");
    chkSinglePlr.setBounds(new Rectangle(8, 75, 139, 23));
    chkCoop.setText("Co-operative");
    chkCoop.setBounds(new Rectangle(8, 103, 139, 23));
    chkEMFH.setText("Every Man for Himself");
    chkEMFH.setBounds(new Rectangle(8, 131, 139, 23));
    chkBall.setText("Kill the Man With the Ball");
    chkBall.setBounds(new Rectangle(8, 159, 185, 23));
    chkKOTH.setText("King of the Hill");
    chkKOTH.setBounds(new Rectangle(8, 188, 139, 23));
    chkCTF.setText("Capture the Flag");
    chkCTF.setBounds(new Rectangle(8, 216, 139, 23));
    chkDefense.setText("Defense");
    chkDefense.setBounds(new Rectangle(8, 244, 139, 23));
    chkRugby.setText("Rugby");
    chkRugby.setBounds(new Rectangle(8, 272, 139, 23));
    btnSave.setBounds(new Rectangle(233, 166, 73, 25));
    btnSave.setText("Save");
    btnSave.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnOK_actionPerformed(e);
      }
    });
    jMenuItem3.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem3_actionPerformed(e);
      }
    });
    jMenuItem3.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem3_actionPerformed(e);
      }
    });
    jMenuItem3.setText("Exit");
    levelSelector.setBounds(new Rectangle(152, 75, 186, 21));
    levelSelector.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        levelSelector_actionPerformed(e);
      }
    });
    jLabel1.setText("Path to map file:");
    jLabel1.setBounds(new Rectangle(10, 8, 105, 15));
    txtPath.setBounds(new Rectangle(9, 32, 234, 21));
    btnLoad.setBounds(new Rectangle(261, 32, 73, 21));
    btnLoad.setText("Load");
    btnLoad.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnLoad_actionPerformed(e);
      }
    });
    jMenuBar1.add(jMenu1);
    jMenu1.add(jMenuItem1);
    jMenu1.add(jMenuItem3);
    this.getContentPane().add(btnLoad);
    this.getContentPane().add(txtPath);
    this.getContentPane().add(jLabel1);
    this.getContentPane().add(chkSinglePlr);
    this.getContentPane().add(chkCoop);
    this.getContentPane().add(chkEMFH);
    this.getContentPane().add(chkBall);
    this.getContentPane().add(chkKOTH);
    this.getContentPane().add(chkCTF);
    this.getContentPane().add(chkDefense);
    this.getContentPane().add(chkRugby);
    this.getContentPane().add(levelSelector);
    this.getContentPane().add(btnSave);
  }

  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItem1 = new JMenuItem();
  JMenuItem jMenuItem3 = new JMenuItem();
  JCheckBox chkSinglePlr = new JCheckBox();
  JCheckBox chkCoop = new JCheckBox();
  JCheckBox chkEMFH = new JCheckBox();
  JCheckBox chkBall = new JCheckBox();
  JCheckBox chkKOTH = new JCheckBox();
  JCheckBox chkCTF = new JCheckBox();
  JCheckBox chkDefense = new JCheckBox();
  JCheckBox chkRugby = new JCheckBox();
  JButton btnSave = new JButton();
  JComboBox levelSelector = new JComboBox();
  JLabel jLabel1 = new JLabel();
  JTextField txtPath = new JTextField();
  JButton btnLoad = new JButton();

  public void jMenuItem3_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  public void jMenuItem1_actionPerformed(ActionEvent e) {
    // Code to open a file.
    String openFile = "";
    final JFileChooser fc = new JFileChooser();
    //fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
    int retVal = fc.showOpenDialog(JUICEFrame.this);
    if(retVal == JFileChooser.APPROVE_OPTION)
        openFile = fc.getSelectedFile().getPath();
    jm.openMapFile(openFile);
    fillLevelSelector();
    loadCheckboxes();
  }

  private void loadCheckboxes(){
    boolean[] flags = jm.fillCheckboxes(getLevelIndex());
    if(flags == null) return;
    if(flags[0]) chkSinglePlr.setSelected(true);
    else chkSinglePlr.setSelected(false);
    if(flags[1]) chkCoop.setSelected(true);
    else chkCoop.setSelected(false);
    if(flags[2]) chkEMFH.setSelected(true);
    else chkEMFH.setSelected(false);
    if(flags[3]) chkBall.setSelected(true);
    else chkBall.setSelected(false);
    if(flags[4]) chkKOTH.setSelected(true);
    else chkKOTH.setSelected(false);
    if(flags[2] && flags[3]) chkCTF.setSelected(true);
    else chkCTF.setSelected(false);
    if(flags[5]) chkDefense.setSelected(true);
    else chkDefense.setSelected(false);
    if(flags[6]) chkRugby.setSelected(true);
    else chkRugby.setSelected(false);
  }

  private void fillLevelSelector(){
    levelSelector.removeAllItems();
    for(int i = 0; i < jm.getNumLevels(); i++){
      levelSelector.addItem(jm.getLevelName(i));
    }
  }

  public void btnOK_actionPerformed(ActionEvent e) {
    boolean[] flagValues = new boolean[8];
    if(chkSinglePlr.isSelected())
      flagValues[0] = true;
    else flagValues[0] = false;
    if(chkCoop.isSelected())
      flagValues[1] = true;
    else flagValues[1] = false;
    if(chkEMFH.isSelected())
      flagValues[2] = true;
    else flagValues[2] = false;
    if(chkBall.isSelected())
      flagValues[3] = true;
    else flagValues[3] = false;
    if(chkKOTH.isSelected())
      flagValues[4] = true;
    else flagValues[4] = false;
    if(chkCTF.isSelected()){
      flagValues[2] = true;
      flagValues[3] = true;
    }
    if(chkDefense.isSelected())
      flagValues[5] = true;
    else flagValues[5] = false;
    if(chkRugby.isSelected())
      flagValues[6] = true;
    else flagValues[6] = false;

    jm.setCheckboxes(getLevelIndex(), flagValues);
    jm.writeData();
  }

  private int getLevelIndex(){
    if(levelSelector.getSelectedIndex() < 0) return 0;
    else return levelSelector.getSelectedIndex();
  }

  public void levelSelector_actionPerformed(ActionEvent e) {
    loadCheckboxes();
  }

  public void btnLoad_actionPerformed(ActionEvent e) {
    jm.openMapFile(txtPath.getText());
    fillLevelSelector();
    loadCheckboxes();

  }

}
