/*
Copyright 2007 Darren Watts

This file is part of JuiceFlag.

JuiceFlag is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JuiceFlag is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JuiceFlag; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
 * @author Darren Watts
 * @version 1.0
 */
public class JUICEModel {

  JUICEFrame jf;
  MapFile mp;
  String currentFile;

  public JUICEModel(JUICEFrame jf) {
    this.jf = jf;
  }

  public void openMapFile(String openFile){
    currentFile = openFile;
    mp = new MapFile(openFile);
  }

  public MapFile getMapFile(){
    return mp;
  }

  public boolean[] fillCheckboxes(int levelIndex){
    return mp.getFlagValues(levelIndex);
  }

  public void setCheckboxes(int levelIndex, boolean[] flagValues){
    mp.setFlagValues(levelIndex, flagValues);
  }

  public void writeData(){
    if(currentFile == null){
      System.out.print("No file to write to");
      return;
    }
    mp.writeFlagValues(currentFile);
  }

  public String getLevelName(int index){
    return mp.getLevelName(index);
  }

  public int getNumLevels(){
    return mp.getLevels();
  }
}
